{% extends "base.html.twig" %}

{% block body %}

    <div class="row">
        <div class="col-6 offset-3 border px-2 py-2 mt-2">
            <center>
                <h1>CMC ChatBot</h1>
            </center>

            <div id="app-messages" style="height: 600px; overflow-y: scroll;">
                <div class="message" v-for="message in messages">
                    <div class="message-from">
                        <strong>
                            {% verbatim %}
                                <span style="font-size: 48px; color: Dodgerblue;">
                                    <i class="fas fa-robot" v-if="message.from == 'Bot'"></i>
                                </span>
                                <span style="font-size: 48px;">
                                    <i class="fa fa-user-astronaut" v-if="message.from != 'Bot'"></i>
                                </span>
                                {{ message.from }}
                            {% endverbatim %}
                        </strong>
                    </div>
                    <div class="message-text">
                        {% verbatim %}
                            {{ message.text }}
                        {% endverbatim %}
                    </div>
                </div>
            </div>


            <form class="input-group" id="app-form">
                <input autocomplete="off" class="form-control" id="message-input" placeholder="Enter your messsage..." type="text" v-on:keyup="keyPress"/>
                <div class="input-group-append">
                    <button class="btn btn-primary" disabled="disabled" id="message-send" v-on:click="send">
                        <i class="fa fa-comment" title="Send"></i>
                    </button>
                </div>
            </form>
        </div>
    </div>
    <footer>
        <!-- Copyright -->
        <div class="footer-copyright text-center py-3">© 2019 Copyright:
            <a href="https://gitlab.com/maxime.simplon/cmc_chatbot">
                CMC ChatBot</a>
        </div>
        <!-- Copyright -->
    </footer>
    <!-- Footer -->

{% endblock %}


{% block javascripts %}
    <script crossorigin="anonymous" integrity="sha256-1Q2q5hg2YXp9fYlM++sIEXOcUb8BRSDUsQ1zXvLBqmA=" src="https://cdnjs.cloudflare.com/ajax/libs/vue/2.5.13/vue.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/axios/0.17.1/axios.min.js"></script>
    <script type="text/javascript">
        var messages = [{
                from: 'Bot',
                text: 'Welcome ! Enter the name of a top 100 crypto currency to know his price'
            }];
        var app = new Vue({
            el: '#app-messages',
            data: {
                messages: messages
            },
            updated: function () { // Scroll to the bottom of the window.
                $("#app-messages").scrollTop($("#app-messages")[0].scrollHeight);
            }
        });

        var appForm = new Vue({
            el: '#app-form',
            methods: { // Handles a character being typed into the input box
                keyPress: function (event) {
                    if (event.target.value == '') { // No text is present, so disabled the 'Send' button
                        $('#message-send').attr('disabled', 'disabled');
                    } else {
                        $('#message-send').removeAttr('disabled');
                    }
                },

                // Sends the message to the bot, and displays the response
                send: function (event) {
                    event.preventDefault();
                    var message = $('#message-input').val();

                    // Add the sent message to the message list
                    messages.push({from: 'You', text: message});
                    // Clear the inputs
                    $('#message-input').val('');
                    $('#message-send').attr('disabled', 'disabled');

                    // Build up the form data
                    const data = new FormData();
                    data.append('driver', 'web');
                    data.append('message', message);

                    // Send the message
                    axios.post('/message', data).then(function (response) { // Add the response to the messages array
                        messages.push({from: 'Bot', text: response.data.messages[0].text});
                    });
                }
            }
        });
    </script>
{% endblock %}
